/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_CONCURRENCY_NOB_H
#define _NEST_CONCURRENCY_NOB_H

#include "nest_concurrency_model.h"
#include "nest_nonblocking_transfers.h"
#include "nest_concurrency_manager.h"

class
nestConcurrencyNob : public nestConcurrencyModel {

  public:
    
    nestConcurrencyNob(
		int pool_size,
		fd_set *readfds,
		fd_set *writefds,
		int id,
		nestStorageManager *sm,
		nestProtocolManager *pm,
		nestConcurrencyManager *cm );
	virtual ~nestConcurrencyNob( void );

    virtual NestReplyStatus makeProgress( fd_set *r_ready, fd_set *w_ready );

    virtual int getMaxfd( );

    virtual NestReplyStatus addTask( nestClient *client );

    virtual int getConcurrencyCount( );

    virtual char* toString();

private:
    NestReplyStatus endTransfer(    nestNonblockingTransfer *transfer,
                                    NestReplyStatus nest_error );

    list< nestNonblockingTransfer* > transfers;
    int maxfd;
    fd_set *readfds;
    fd_set *writefds;
    nestConcurrencyManager *manager;
}; 

#endif

