/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_CONCURRENCY_POP_H
#define _NEST_CONCURRENCY_POP_H

#include "nest_concurrency_model.h"
#include "nest_concurrency_manager.h"
#include "nest_client_pool.h"
#include "nest_worker_pool.h"

class nestConcurrencyPop : public nestConcurrencyModel {
public:
    
    nestConcurrencyPop(
		int pool_size,
		fd_set *srvr_read_fds,
		fd_set *srvr_write_fds,
		int id,
		nestStorageManager *sm,
		nestProtocolManager *pm,
		nestConcurrencyManager *cm );
    virtual ~nestConcurrencyPop( void );
    
    virtual NestReplyStatus addTask( nestClient *client );
    
    virtual NestReplyStatus makeProgress( fd_set *r_ready, fd_set *w_ready );

    virtual int getMaxfd();

    virtual NestReplyStatus sigChild( int sig, siginfo_t *info, void *context,
            fd_set *ready );

    virtual NestReplyStatus debugLevel( long new_level );

    virtual char* toString();

private:
    int HandleWorkerMessages( fd_set *r_ready );
    void testWorkers( );
    void replaceDeadChildren( int quantity );
    void assignPendingReqs( int new_idle_workers );

	nestProtocolManager *protocols;
	nestConcurrencyManager *manager;

    nestClientPool   *pendingReqs;
    nestWorkerPool   *workers;
    fd_set           *readfds;
    int              deadKids;
};

#endif
