/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_FILECACHE_MODEL_INFINITE_H
#define NEST_FILECACHE_MODEL_INFINITE_H

#include <stdio.h>
#include <assert.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "nest_common.h"
// #include "nest_filecache_model_simple.h"
#include "nest_hash_table.h"

class nestFilecacheModelInfinite : public nestFilecacheModel {

public:

    nestFilecacheModelInfinite( int hashsize );

    virtual NestReplyStatus insert( bool *hit, const char *file, long size );

    virtual bool remove( const char *file );
    
    virtual bool check( const char *file );

    virtual void debug( );

    virtual bool grow( float megs );

    virtual bool shrink( float megs );

    virtual bool renameFile( const char *oldname, const char *newname );

    virtual float hit_rate( );
    
    virtual long gethits( );

    virtual long getmisses( );
    
    virtual long getevictions( );
    
    virtual float getsize( );

    virtual long getavail( );

    virtual long getentries( );
    
    virtual long getFilesize( const char *file );

    virtual void setFilesize( const char *file, long size );

    virtual void writeAd( nestProtocol *ad );

    virtual NestReplyStatus format();

    virtual bool rememberLength( const char *file, long *length );
    
private:
    struct nest_hash_table *infinite_cache;
    unsigned long hits, misses; 
    long size;
};

#endif
