/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_NONBLOCKING_TRANSFERS
#define _NEST_NONBLOCKING_TRANSFERS

#include "nest_concurrency_model.h"
#include "nest_common.h"
#include "nest_client.h"

#define TRANSFER_ITERATOR list< nestNonblockingTransfer *>::iterator

enum{ WRITE_DONE, WRITE_OK, WRITE_INCOMPLETE, READ_DONE, READ_OK, CLIENT_LOST };

class 
nestNonblockingTransfer {

public:

    nestNonblockingTransfer( nestClient *transfer );

    ~nestNonblockingTransfer( );

    static nestNonblockingTransfer* newTransfer( nestClient *client, 
            NestReplyStatus &status );
    
    nestClient* getClient( );
    
    int getSrc( );

    int getDst( );

    int getCsd( );
    int getRealClientSocket();

    int getMaxfd( );

    int getType( );

    int getStatus( );

    int writeDst( );

    int readSrc( );

    int sendInitialAck( );
    bool ackSent( );

    bool sendFinalAck(); 

    bool sendErrorMessage(  const char* filename, const char* func_name, NestReplyStatus error );
    
    void endTransfer( bool status );

    long getLength( ) { return filetransfer->getLength(); }

private:

    // TODO: I think csd is not necessary
    nestProtocol *csd;
    nestProtocol *src;
    nestProtocol *dst;
    int     status;
    int     type;
    long    transferoffset;
    char   *buffer;
    ssize_t bufferoffset;
    ssize_t buffersize;    // how many bytes currently in buffer
    bool     acksent;
    nestClient *client;
    nestFiletransfer *filetransfer;
    struct IO_Measurement *measurements;
};

#endif
