/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_STORAGE_FD_CACHE_H
#define NEST_STORAGE_FD_CACHE_H

#include "nest_common.h"

struct ltstr {
    bool operator()(const char* s1, const char* s2) const {
        return strcmp(s1, s2) < 0;
    }
};

#define LIST_ITR list<cache_entry*>::iterator
#define MAP_ITR  multimap<const char*,LIST_ITR,ltstr>::iterator

typedef struct {
    int fd;
    char *key;
} cache_entry;

class
nestFdCache {

public:
    nestFdCache( unsigned max_size );

    ~nestFdCache( );

    bool stow( int fd, const char *key ); 

        // returns fd if found, -1 otherwise
    int  lookup( const char *key ); 

    int getSize( );

    int invalidateAll( const char *subkey );

private:
    void makeSpace();
    void removeEntry( cache_entry *old );

    unsigned max_size;
    list<cache_entry*> cache_list;
    multimap< const char *, LIST_ITR, ltstr > cache_map;
};

#endif
