/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_WORKER_H
#define NEST_WORKER_H

#include "nest_common.h"
#include "nest_filetransfer.h"
#include "nest_client.h"
#include "nest_protocol_manager.h"

// functions are defined in nest_worker.C

class 
nestWorker {

  public:

    nestWorker( pid_t pid, int stream, int id, nestProtocolManager *pm );

    bool sendMessage( const char * msg );

    bool canReceiveMessage( fd_set *readyfds );

    pid_t getPid( );

    int getStream( );

    bool isIdle( );

    void setIdle( int state );

    NestReplyStatus assignTask( nestClient *client ); 
    
    void endTask( bool success, long bytes_transferred );

    nestClient* getClient( );

    int  getID( );

private:

    pid_t pid;
    int   stream;
    int   id;    
    int   idle;
    nestFiletransfer *currentTask;
	nestProtocolManager *protocol_manager;
    nestClient *client;
};

#endif
