/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
/* This particular file was written by Muthian Sivathanu */

#include <rpc/svc.h>
#include <rpc/auth_unix.h>

#define RQCRED_SIZE 400

struct xp_ops {
    bool_t    (*xp_recv) __PMT ((SVCXPRT *__xprt, struct rpc_msg *__msg));
                /* receive incoming requests */
    enum xprt_stat (*xp_stat) __PMT ((SVCXPRT *__xprt));
                /* get transport status */
    bool_t    (*xp_getargs) __PMT ((SVCXPRT *__xprt, xdrproc_t __xdr_args,
                      caddr_t args_ptr)); /* get arguments */
    bool_t    (*xp_reply) __PMT ((SVCXPRT *__xprt, struct rpc_msg *__msg));
                /* send reply */
    bool_t    (*xp_freeargs) __PMT ((SVCXPRT *__xprt, xdrproc_t __xdr_args,
                       caddr_t args_ptr));
                /* free mem allocated for args */
    void    (*xp_destroy) __PMT ((SVCXPRT *__xprt));
                /* destroy this struct */
};


typedef void (*svc_dispatch)(struct svc_req *, SVCXPRT *);

SVCXPRT *
my_svcudp_create (int sock);

extern "C" {
    void my_svcudp_destroy (SVCXPRT *xprt, int to_close);
}

void
my_svc_getreqset (svc_dispatch disp_fn, fd_set *readfds );

void
my_svc_getreq_common (svc_dispatch disp_fn, const int fd);

int
my_svc_run (svc_dispatch disp_fn);
